package cn.iocoder.yudao.module.system.service.biz;


import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.*;
import cn.iocoder.yudao.module.system.dal.dataobject.biz.DeviceCategoryDO;
import cn.iocoder.yudao.module.system.dal.dataobject.biz.DeviceModelDO;
import cn.iocoder.yudao.module.system.dal.dataobject.biz.ModelFieldDO;

import javax.validation.Valid;
import java.util.List;

/**

 */
public interface DeviceModelService {

    /**
     * 创建设备模型
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long saveModel(@Valid DeviceModelSaveReqVO createReqVO);

    /**
     * 更新设备模型
     *
     * @param updateReqVO 更新信息
     */
    void updateModel(@Valid DeviceModelSaveReqVO updateReqVO);

    /**
     * 删除设备模型
     *
     * @param id 编号
     */
    void deleteModel(Long id);

    /**
     * 获得设备模型
     *
     * @param id 编号
     * @return 设备模型
     */
    DeviceModelRespVO getModel(Long id);

    /**
     * 获得设备模型分页
     *
     * @param pageReqVO 分页查询
     * @return 设备模型分页
     */
    PageResult<DeviceModelDO> getModelPage(DeviceModelPageReqVO pageReqVO);

    List<DeviceModelDO> getSubList(Long parentId);

    List<ModelFieldDO> getModelFielList(Long id);

    List<ModelTableFieldVO> getOriginalModelFielList(Integer type);

    DeviceModelCountVO getCount(Long deviceCategoryId);

    List<ManufacturerModelRespVO> getManufacturerModelList();
}
